Project Chrono: chrono::ChLoadNodeXYZBody Class Reference

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
chrono::ChLoadNodeXYZBody Class Referenceabstract

## Description

Base class for loads representing a concentrated force acting between a ChNodeXYZ and a ChBody Users should inherit from this and implement a custom ComputeForce().

Note: there are already some predefined examples, ie. children classes with common concrete implementations, such as ChLoadNodeXYZBodySpring ChLoadNodeXYZBodyBushing etc.; take inspiration from those example to inherit your own load if they are not enough.

`#include <ChLoadsNodeXYZ.h>`

Inheritance diagram for chrono::ChLoadNodeXYZBody:
[legend]
Collaboration diagram for chrono::ChLoadNodeXYZBody:
[legend]

## Public Member Functions
| ChLoadNodeXYZBody (std::shared_ptr< ChNodeXYZ > node, std::shared_ptr< ChBody > body)
virtual void | ComputeForce (const ChFrameMoving<> &rel_AB, ChVector3d &loc_force)=0
| Compute the force on the nodeA, in local coord system, given relative position of nodeA respect to B.
ChVector3d | GetForce () const
| Return the last computed value of the applied force.
void | SetApplicationFrameB (const ChFrame<> &application_frame)
| Set the application frame of load on body.
ChFrame | GetApplicationFrameB () const
| Get the application frame of load on body.
ChFrameMoving | GetAbsoluteFrameB () const
| Get absolute coordinate of body frame (last computed).
std::shared_ptr< ChNodeXYZ > | GetNode () const
std::shared_ptr< ChBody > | GetBody () const
Public Member Functions inherited from chrono::ChLoadCustomMultiple
| ChLoadCustomMultiple (std::vector< std::shared_ptr< ChLoadable > > &loadable_objects)
| ChLoadCustomMultiple (std::shared_ptr< ChLoadable > loadableA, std::shared_ptr< ChLoadable > loadableB)
| ChLoadCustomMultiple (std::shared_ptr< ChLoadable > loadableA, std::shared_ptr< ChLoadable > loadableB, std::shared_ptr< ChLoadable > loadableC)
virtual int | LoadGetNumCoordsPosLevel () override
| Gets the number of DOFs affected by this load (position part).
virtual int | LoadGetNumCoordsVelLevel () override
| Gets the number of DOFs affected by this load (speed part).
virtual void | LoadGetStateBlock_x (ChState &mD) override
| Gets all the current DOFs packed in a single vector (position part).
virtual void | LoadGetStateBlock_w (ChStateDelta &mD) override
| Gets all the current DOFs packed in a single vector (speed part).
virtual void | LoadStateIncrement (const ChState &x, const ChStateDelta &dw, ChState &x_new) override
| Increment a packed state (e.g., as obtained by LoadGetStateBlock_x()) by a given packed state-delta.
virtual int | LoadGetNumFieldCoords () override
| Number of coordinates in the interpolated field.
virtual void | ComputeJacobian (ChState *state_x, ChStateDelta *state_w) override
| Compute Jacobian matrices K=-dQ/dx, R=-dQ/dv, and M=-dQ/da.
virtual void | LoadIntLoadResidual_F (ChVectorDynamic<> &R, double c) override
| Add the internal loads Q (pasted at global offsets) into a global vector R, multiplied by a scaling factor c.
virtual void | LoadIntLoadResidual_Mv (ChVectorDynamic<> &R, const ChVectorDynamic<> &w, double c) override
| Increment a vector R with the matrix-vector product M*w, scaled by the factor c.
virtual void | LoadIntLoadLumpedMass_Md (ChVectorDynamic<> &Md, double &err, const double c) override
| Add the lumped mass to an Md vector, representing a mass diagonal matrix.
virtual void | CreateJacobianMatrices () override
| Create the Jacobian loads if needed and set the ChVariables referenced by the sparse KRM block.
virtual ChVectorDynamic & | GetQ ()
| Access the generalized load vector Q.
Public Member Functions inherited from chrono::ChLoadBase
ChLoadJacobians * | GetJacobians ()
| Access the Jacobians (if any, i.e. if this is a stiff load).
virtual void | Update (double time)
| Update, called at least at each time step.
virtual bool | IsStiff ()=0
| Report if this is load is stiff.
virtual void | InjectKRMMatrices (ChSystemDescriptor &descriptor)
| Register with the given system descriptor any ChKRMBlock objects associated with this item.
virtual void | LoadKRMMatrices (double Kfactor, double Rfactor, double Mfactor)
| Compute and load current stiffnes (K), damping (R), and mass (M) matrices in encapsulated ChKRMBlock objects.
Public Member Functions inherited from chrono::ChObj
| ChObj (const ChObj &other)
virtual ChObj * | Clone () const =0
| "Virtual" copy constructor.
int | GetIdentifier () const
| Get the unique integer identifier of this object.
void | SetTag (int tag)
| Set an object integer tag (default: -1).
int | GetTag () const
| Get the tag of this object.
void | SetName (const std::string &myname)
| Set the name of this object.
const std::string & | GetName () const
| Get the name of this object.
double | GetChTime () const
| Gets the simulation time of this object.
void | SetChTime (double m_time)
| Sets the simulation time of this object.
virtual void | ArchiveOut (ChArchiveOut &archive_out)
| Method to allow serialization of transient data to archives.
virtual void | ArchiveIn (ChArchiveIn &archive_in)
| Method to allow de-serialization of transient data from archives.
virtual std::string & | ArchiveContainerName ()

## Protected Member Functions
virtual void | ComputeQ (ChState *state_x, ChStateDelta *state_w) override
| Compute Q, the generalized load.
Protected Member Functions inherited from chrono::ChObj
int | GenerateUniqueIdentifier ()

## Protected Attributes
ChFrame | loc_application_B
| application point on body B (local)
ChVector3d | computed_loc_force
| store computed values here
ChFrameMoving | frame_Aw
| for results
ChFrameMoving | frame_Bw
| for results
Protected Attributes inherited from chrono::ChLoadBase
ChLoadJacobians * | m_jacobians
Protected Attributes inherited from chrono::ChObj
double | ChTime
| object simulation time
std::string | m_name
| object name
int | m_identifier
| object unique identifier
int | m_tag
| user-supplied tag

## Additional Inherited Members
Public Attributes inherited from chrono::ChLoadCustomMultiple
std::vector< std::shared_ptr< ChLoadable > > | loadables
ChVectorDynamic | load_Q

## Constructor & Destructor Documentation

## ◆ ChLoadNodeXYZBody()

chrono::ChLoadNodeXYZBody::ChLoadNodeXYZBody | ( | std::shared_ptr< ChNodeXYZ > | node,
|  | std::shared_ptr< ChBody > | body )

Parameters

  node | node
  body | body

## Member Function Documentation

## ◆ ComputeForce()

virtual void chrono::ChLoadNodeXYZBody::ComputeForce | ( | const ChFrameMoving<> & | rel_AB,
|  | ChVector3d & | loc_force )
| pure virtual

Compute the force on the nodeA, in local coord system, given relative position of nodeA respect to B.

The local coordinate system is that specified with SetApplicationFrameB (the auxiliary frame attached to body).

Implemented in chrono::ChLoadNodeXYZBodyBushing, and chrono::ChLoadNodeXYZBodySpring.

## ◆ ComputeQ()

void chrono::ChLoadNodeXYZBody::ComputeQ | ( | ChState * | state_x,
|  | ChStateDelta * | state_w )
| overrideprotectedvirtual

Compute Q, the generalized load.

It calls ComputeBodyBodyForceTorque, so in children classes you do not need to implement it. Called automatically at each Update().

Parameters

  state_x | state position to evaluate Q
  state_w | state speed to evaluate Q

Implements chrono::ChLoadBase.

## ◆ GetForce()

ChVector3d chrono::ChLoadNodeXYZBody::GetForce | ( |  | ) | const
| inline

Return the last computed value of the applied force.

Used primarily for diagnostics, this function returns the force on the node expressed in absolute coordinates.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChLoadsNodeXYZ.h
- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChLoadsNodeXYZ.cpp